package plan9

import Chisel._

class BRAM1toN(addressBits: Int, dataBits: Int, readPorts: Int) extends BlackBox {
  val io = new Bundle {
    val writeEnabled = Bool(INPUT)
    writeEnabled.setName("write_enabled")
    val writeAddress = Bits(INPUT, width=addressBits)
    writeAddress.setName("write_address")
    val writeData = Bits(INPUT, width=dataBits)
    writeData.setName("write_data")

    val readAddressSlv = Bits(INPUT, width=readPorts*addressBits)
    readAddressSlv.setName("read_address_slv")
    val readDataSLV = Bits(OUTPUT, width=readPorts*dataBits)
    readDataSLV.setName("read_data_slv")
  }

  setVerilogParameters(new VerilogParameters {
                         val address_bits = addressBits
                         val data_bits = dataBits
                         val read_ports = readPorts
                       })
  setModuleName("bram_1toN")
  addClock(Driver.implicitClock)
  renameClock(Driver.implicitClock, "clock")
}
