package plan9

import Chisel._

class Fifo(
  AddressBits: Int,
  DataBits: Int
) extends BlackBox {
  val io = new Bundle {
    val dataIn = Bits(INPUT, width=DataBits)
    dataIn.setName("data_in")
    val dataOut = Bits(OUTPUT, width=DataBits)
    dataOut.setName("data_out")
    val dataCount = Bits(OUTPUT, width=AddressBits)
    dataCount.setName("data_count")
    val dataRead = Bool(INPUT)
    dataRead.setName("data_read")
    val dataWrite = Bool(INPUT)
    dataWrite.setName("data_write")
    // val reset = Bool(INPUT)
    // reset.setName("reset")
  }
  setVerilogParameters(new VerilogParameters {
    val address_bits = AddressBits
    val data_bits = DataBits
  })
  addClock(Driver.implicitClock)
  renameClock("clk", "clock")
}
