package plan9

import Chisel._

class LiveCounter(cellAmount: Int) extends BlackBox {
  val io = new Bundle {
    val run = Bool(INPUT)
    run.setName("run")
    val cellStates = Bits(INPUT, width=cellAmount)
    cellStates.setName("cell_states")
    val liveCount = Bits(OUTPUT, width=log2Up(cellAmount))
    liveCount.setName("live_count")
    val writeCount = Bool(OUTPUT)
    writeCount.setName("write_count")
  }

  setVerilogParameters(new VerilogParameters {
                         val cell_amount = cellAmount
                       })
  setModuleName("live_counter")
  addClock(Driver.implicitClock)
  renameClock(Driver.implicitClock, "clock")
}
