package plan9

import Chisel._
import card._

import java.io.PrintWriter
import java.io.File

class Toplevel(apb_addr_size: Int, apb_data_size: Int, mem_addr_size: Int, mem_data_size: Int) extends Module {

   //val tx_buffer_address_bits   = 8
   //val rx_buffer_address_bits   = 8
   //val reverse_payload_endian   = true
   //val program_counter_bits     = 8
   //val matrix_width             = 8
   //val matrix_height            = 8
   //val matrix_depth             = 8
   //val matrix_wrap              = true
   //val cell_type_bits           = 5
   //val cell_state_bits          = 1
   //val jump_counters            = 4
   //val jump_counter_bits        = 16
   //val instruction_bits         = 256
   //val lut_configuration_bits   = 8
   //val rule_amount              = 256
   //val rules_tested_in_parallel = 4
   //val rule_vector_amount       = 64
   //val live_count_buffer_size   = 256
   //val fitness_buffer_size      = 256
  val carpParams = DefaultParams

   /////////////////////////////////////////////////////////////////////////////

   val io = new Bundle {
      val apb = new ApbBus(apb_addr_size, apb_data_size)
      val mem = new MemPortIo(mem_addr_size, mem_data_size)
   }

   /////////////////////////////////////////////////////////////////////////////

  val comm = Module(new Communication(
    apb_addr_size,
    apb_data_size,
    mem_addr_size,
    mem_data_size,
    carpParams.TxBufferAddressBits,
    carpParams.RxBufferAddressBits,
    carpParams.ReversePayloadEndian
  ))

   comm.io.apb <> io.apb
   comm.io.mem <> io.mem

   val carp = Module(new Carp(carpParams))

   comm.io.comm <> carp.io.comm
}

