package plan9

import Chisel._

class SBlock(neighborhoodSize: Int, LUTConfigurationBits: Int) extends BlackBox {
  val io = new Bundle {
    val state = Bool(OUTPUT)
    state.setName("state")
    val neighborStates = Bits(INPUT, width=neighborhoodSize)
    neighborStates.setName("neighbor_states")
    val configurationLUT = Bits(INPUT, width=LUTConfigurationBits)
    configurationLUT.setName("configuration_lut")
    val configurationState = Bool(INPUT)
    configurationState.setName("configuration_state")
    val configurationEnable = Bool(INPUT)
    configurationEnable.setName("configuration_enable")
    val update = Bool(INPUT)
    update.setName("update")
  }

  setVerilogParameters(
    new VerilogParameters {
      val neighborhood_size = neighborhoodSize
      val lut_configuration_bits = LUTConfigurationBits
    }
  )

  addClock(Driver.implicitClock)
  renameClock(Driver.implicitClock, "clock")
}
