package plan9

import Chisel._

class Selector(entryBits: Int, entryNumber: Int) extends BlackBox {
  val io = new Bundle {
    val entriesIn = Bits(INPUT, width=entryNumber*entryBits)
    entriesIn.setName("entries_in")
    val entryOut = Bits(OUTPUT, width=entryBits)
    entryOut.setName("entry_out")
    val selected = Bits(INPUT, width=log2Up(entryNumber))
    selected.setName("selected")
  }

  setVerilogParameters(new VerilogParameters {
                         val entry_bits = entryBits
                         val entry_number = entryNumber
                       })
}
