package plan9

import Chisel._
import Chisel.testers.TesterDriver
import org.junit.Test

class InformationSenderTests(i: InformationSender, cp: CarpParameters) extends Tester(i) {
  poke(i.io.fitnessIdentifier, 2)
  poke(i.io.fitnessWordsPerRun, 1)
  poke(i.io.fitnessParameters, 0)
  poke(i.io.sendBufferCount, 0)
  poke(i.io.decodeOperation, Types.informationSenderOperation('send).litValue())
  poke(i.io.run, true)
  step(1)
  expect(i.io.done, false)
  poke(i.io.sendBufferCount, 16)
  poke(i.io.decodeOperation, Types.informationSenderOperation('nop).litValue())
  step(1)
  expect(i.io.sendBufferWrite, true)
  var expected = Integer.parseInt(Utilities.toBinary(cp.MatrixDepth, width=8) +
                                    Utilities.toBinary(cp.MatrixHeight, 8) +
                                    Utilities.toBinary(cp.MatrixWidth, 8) +
                                    Utilities.toBinary(if (cp.MatrixWrap) 1 else 0, 8), 2)
  expect(i.io.sendBufferData, expected)
  step(1)
  expected = Integer.parseInt(Utilities.toBinary(cp.JumpCounterBits, 8) +
                                Utilities.toBinary(cp.JumpCounters, 8) +
                                Utilities.toBinary(cp.CellTypeBits, 8) +
                                Utilities.toBinary(cp.CellStateBits, 8), 2)
  expect(i.io.sendBufferData, expected)
  step(1)
  expect(i.io.sendBufferData, cp.RuleAmount)
  step(1)
  expected = Integer.parseInt(Utilities.toBinary(0, 16) +
                               Utilities.toBinary(1, 8) +
                               Utilities.toBinary(2, 8), 2)
  expect(i.io.sendBufferData, expected)
  step(1)
  expected = Integer.parseInt(Utilities.toBinary(cp.SNNTopology.length, 16) +
                                Utilities.toBinary(cp.CAOutputCells.length, 16), 2)
  expect(i.io.sendBufferData, expected)
  for (j <- 0 to math.ceil(cp.SNNTopology.length / 2).toInt) {
    step(1)
    expected = Integer.parseInt(
      (if ((j*2) + 1 >= cp.SNNTopology.length) "0" * 16 else Utilities.toBinary(cp.SNNTopology((j*2) + 1))) +
        Utilities.toBinary(cp.SNNTopology(j*2), 16), 2)
    expect(i.io.sendBufferData, expected)
  }
  step(1)
  expect(i.io.sendBufferWrite, false)
  expect(i.io.sendBufferData, 0)
}

object InformationSenderTest {
  def test() {
    val args = Array[String]("--backend", "c", "--compile", "--genHarness", "--test", "--targetDir", TestHelpers.dir.getPath.toString())
    chiselMainTest(args, () => Module(new InformationSender(DefaultParams))){i => new InformationSenderTests(i, DefaultParams)}
  }
}
