package plan9

import Chisel._
import Chisel.testers.TesterDriver
import org.junit.Test

class LUTWriterTests(lutWriter: LUTWriter) extends Tester(lutWriter) {
  poke(lutWriter.io.decodeOperation, Types.lutWriterOperation('nop).litValue())
  poke(lutWriter.io.run, false)
  poke(lutWriter.io.decodeAddress, 10)
  poke(lutWriter.io.decodeData, 1)
  step(1)
  expect(lutWriter.io.lutStorageWrite, false)
  expect(lutWriter.io.lutStorageData, 1)
  expect(lutWriter.io.lutStorageAddress, 10)
  poke(lutWriter.io.run, true)
  step(1)
  expect(lutWriter.io.lutStorageWrite, false)
  poke(lutWriter.io.decodeOperation, Types.lutWriterOperation('store).litValue())
  step(1)
  expect(lutWriter.io.lutStorageWrite, true)
}

object LUTWriterTest {
  def test() {
    val args = Array[String]("--backend", "c", "--compile", "--genHarness", "--test", "--targetDir", TestHelpers.dir.getPath.toString())
    chiselMainTest(args, () => Module(new LUTWriter(DefaultParams))){l => new LUTWriterTests(l)}
  }
}
