package plan9

import Chisel._
import Chisel.testers.TesterDriver
import org.junit.Test

class NeuronTests(neuron: Neuron) extends Tester(neuron) {
  poke(neuron.io.input, 15) // 15 => 0b1111
  expect(neuron.io.activationValue, false)
  step(1)
  poke(neuron.io.weightAddr, 0)
  poke(neuron.io.weightData, 2)
  poke(neuron.io.weightWrite, true)
  step(1)
  poke(neuron.io.weightAddr, 1)
  poke(neuron.io.weightData, 3)
  step(1)
  poke(neuron.io.weightAddr, 2)
  poke(neuron.io.weightData, 2)
  step(1)
  poke(neuron.io.weightAddr, 3)
  step(1)
  poke(neuron.io.weightWrite, false)
  poke(neuron.io.run, true)
  step(1)
  expect(neuron.io.activationValue, false)
  step(1)
  expect(neuron.io.activationValue, false)
  step(1)
  expect(neuron.io.activationValue, true)
  step(1)
  expect(neuron.io.activationValue, false)
  step(1)
  expect(neuron.io.activationValue, false)
  step(1)
  expect(neuron.io.activationValue, true)
}

object NeuronTest {
  def test() {
    val args = Array[String]("--backend", "c", "--compile", "--genHarness", "--test", "--targetDir", TestHelpers.dir.getPath.toString())
    chiselMainTest(args, () => Module(new Neuron(IncomingEdges = 4, WeightWidth = 8))){n => new NeuronTests(n)}
  }
}
