package plan9

import Chisel._
import Chisel.testers.TesterDriver
import org.junit.Test

class ReadoutSenderTests(readoutSender: ReadoutSender) extends Tester(readoutSender) {
  poke(readoutSender.io.decodeOperation, Types.readoutSenderOperation('send).litValue())
  poke(readoutSender.io.readoutBufferCount, 32)
  step(1)
  expect(readoutSender.io.done, true)
  expect(readoutSender.io.readoutBufferRead, false)
  expect(readoutSender.io.sendBufferWrite, false)
  poke(readoutSender.io.run, true)
  step(1)
  expect(readoutSender.io.done, false)
  expect(readoutSender.io.readoutBufferRead, false)
  expect(readoutSender.io.sendBufferWrite, false)
  poke(readoutSender.io.run, false)
  for (i <- 1 to 32) {
    step(1)
    expect(readoutSender.io.done, false)
    expect(readoutSender.io.readoutBufferRead, true)
    expect(readoutSender.io.sendBufferWrite, true)
  }
  step(1)
  expect(readoutSender.io.done, true)
  expect(readoutSender.io.readoutBufferRead, false)
  expect(readoutSender.io.sendBufferWrite, false)
}

object ReadoutSenderTest {
  def test() {
    val args = Array[String]("--backend", "c", "--compile", "--genHarness", "--test", "--targetDir", TestHelpers.dir.getPath.toString())
    chiselMainTest(args, () => Module(new ReadoutSender(DefaultParams))){l => new ReadoutSenderTests(l)}
  }
}
