package plan9

import Chisel._
import Chisel.testers.TesterDriver
import org.junit.Test

class ReadoutTests(r: Readout) extends Tester(r) {
  poke(r.io.decodeOperation, Types.readoutOperation('writeWeight).litValue())
  poke(r.io.weightData, 2)
  poke(r.io.weightAddr, 2)
  step(1)
  poke(r.io.decodeOperation, Types.readoutOperation('nop).litValue())
  poke(r.io.run, true)
  step(2)
  expect(r.io.output, 0)
  step(1)
  expect(r.io.output, 1)
  step(1)
  expect(r.io.output, 0)
  step(1)
  expect(r.io.output, 1)
  step(1)
  expect(r.io.output, 0)
  step(1)
  expect(r.io.output, 1)
  step(1)
  expect(r.io.output, 0)
}

object TestParams extends CarpParameters {
  CAOutputCells = Array(Array(0,0,0))
  SNNTopology = Array(2, 1)
}

object ReadoutTest {
  def test() {
    val args = Array[String]("--backend", "c", "--compile", "--genHarness", "--test", "--targetDir", TestHelpers.dir.getPath.toString())
    chiselMainTest(args, () => Module(new Readout(TestParams))){r => new ReadoutTests(r)}
  }
}
