package plan9

import Chisel._

class SNNLayerTests(sl: SNNLayer) extends Tester(sl) {
  poke(sl.io.weightAddr, 0)
  poke(sl.io.weightData, 2)
  poke(sl.io.weightWrite, true)
  step(1)
  poke(sl.io.weightAddr, 2)
  step(1)
  poke(sl.io.weightWrite, false)
  poke(sl.io.input, 2)
  poke(sl.io.run, true)
  step(1)
  expect(sl.io.activationValues, 0)
  step(1)
  expect(sl.io.activationValues, 0)
  poke(sl.io.input, 1)
  step(1)
  expect(sl.io.activationValues, 0)
  step(1)
  expect(sl.io.activationValues, 3)
}

object SNNLayerTest {
  def test() {
    val testArgs = Array[String]("--backend", "c", "--compile", "--genHarness", "--test", "--targetDir", TestHelpers.dir.getPath.toString())
    chiselMainTest(testArgs, () => Module(new SNNLayer(2, 2, 8))){ c => new SNNLayerTests(c)}
  }
}
