/*****************************************************************************
 * Communication interface
 *
 * An abstraction layer above the Convey interface.
 *
 * Asbjørn Djupdal 2016
 *****************************************************************************/

#ifndef COMMUNICATION_H
#define COMMUNICATION_H

#include <stdint.h>

/* Main interface */
void communication_open(void);
void communication_close(void);
void communication_send(uint64_t *buffer, int words);
void communication_receive(uint64_t *buffer, int words);

/* Special requests */
uint32_t communication_tx_count(void);
uint32_t communication_tx_space(void);
uint32_t communication_rx_count(void);
uint32_t communication_rx_space(void);

#endif

