#include "snn.h"

void print_network(snn_t* network) {
  int neurons_previous_layer = network->input_count;
  for (int i = 0; i < network->layer_count; i++) {
    snn_layer_t* layer = &(network->layers[i]);
    for (int j = 0; j < layer->neuron_count; j++) {
      neuron_t* neuron = &(layer->neurons[j]);
      for (int k = 0; k < neurons_previous_layer; k++) {
        printf("%d ", neuron->weights[k]);
      }
      printf("\t");
    }
    printf("\n");
    neurons_previous_layer = layer->neuron_count;
  }
}

snn_t* create_network(carp_info_t* info) {
  snn_t* network = (snn_t*) malloc(sizeof(snn_t));
  network->input_count = info->ca_output_cell_count;
  network->layer_count = info->readout_layer_count;
  int neurons_previous_layer = network->input_count;
  network->layers = (snn_layer_t*) malloc(network->layer_count * sizeof(snn_layer_t));
  for (int i = 0; i < network->layer_count; i++) {
    snn_layer_t* layer = &(network->layers[i]);
    layer->neuron_count = info->readout_topology[i];
    layer->neurons = (neuron_t*) malloc(layer->neuron_count * sizeof(neuron_t));
    for (int j = 0; j < layer->neuron_count; j++) {
      layer->neurons[j].weights = (uint8_t*) calloc(neurons_previous_layer, sizeof(uint8_t));
    }
    neurons_previous_layer = layer->neuron_count;
  }
  return network;
}
