#include "carp.h"
#include "print.h"
#include "postscript.h"

carp_info_t *info;

void init() {
  // Main loop
  rule_t rule_create_1_from_C_low = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = true,  .state_value = 0, .type_check = true,  .type_value = 0xC},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 1},
  };
  rule_t rule_create_2 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 1},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 2},
  };
  rule_t rule_create_3 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 2},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 3},
  };
  rule_t rule_create_4 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 3},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 4},
  };
  rule_t rule_create_5 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 4},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 5},
  };
  rule_t rule_create_6 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 5},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 6},
  };
  rule_t rule_create_7 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 6},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 7},
  };
  rule_t rule_create_8 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 7},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 8},
  };
  rule_t rule_create_9 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 2},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 6},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 8},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 4},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 9},
  };
  // A
  rule_t rule_create_A = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false,  .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 1},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 0xA},
  };
  // B
  rule_t rule_create_B = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 3},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false,  .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .result     = {.state_change = false, .state_value = 0, .type_change = true, .type_value = 0xB},
  };

  // Kill rules
  rule_t rule_kill_1_from_high_C = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = true,  .state_value = 1, .type_check = true,  .type_value = 0xC},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 1},
    .result     = {.state_change = true, .state_value = 0, .type_change = true, .type_value = 0},
  };
  rule_t rule_kill_3_from_high_C = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = true,  .state_value = 1, .type_check = true,  .type_value = 0xC},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 3},
    .result     = {.state_change = true, .state_value = 0, .type_change = true, .type_value = 0},
  };
  rule_t rule_kill_5_from_high_C = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = true,  .state_value = 1, .type_check = true,  .type_value = 0xC},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 5},
    .result     = {.state_change = true, .state_value = 0, .type_change = true, .type_value = 0},
  };
  rule_t rule_kill_7_from_high_C = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = true,  .state_value = 1, .type_check = true,  .type_value = 0xC},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 7},
    .result     = {.state_change = true, .state_value = 0, .type_change = true, .type_value = 0},
  };
  rule_t starve_2 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 2},
    .result     = {.state_change = true, .state_value = 0, .type_change = true, .type_value = 0},
  };
  rule_t starve_4 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 4},
    .result     = {.state_change = true, .state_value = 0, .type_change = true, .type_value = 0},
  };
  rule_t starve_6 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 6},
    .result     = {.state_change = true, .state_value = 0, .type_change = true, .type_value = 0},
  };
  rule_t starve_8 = {
    .z_negative = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .z_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .y_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .y_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .x_negative = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 0},
    .x_positive = {.state_check = false, .state_value = 0, .type_check = false, .type_value = 0},
    .self       = {.state_check = false, .state_value = 0, .type_check = true,  .type_value = 8},
    .result     = {.state_change = true, .state_value = 0, .type_change = true, .type_value = 0},
  };


  int index = 0;

  write_rule(rule_create_1_from_C_low, ++index);
  write_rule(rule_create_2, ++index);
  write_rule(rule_create_3, ++index);
  write_rule(rule_create_4, ++index);
  write_rule(rule_create_5, ++index);
  write_rule(rule_create_6, ++index);
  write_rule(rule_create_7, ++index);
  write_rule(rule_create_8, ++index);
  write_rule(rule_create_9, ++index);
  write_rule(rule_create_A, ++index);
  write_rule(rule_create_B, ++index);
  write_rule(rule_kill_1_from_high_C, ++index);
  write_rule(rule_kill_3_from_high_C, ++index);
  write_rule(rule_kill_5_from_high_C, ++index);
  write_rule(rule_kill_7_from_high_C, ++index);
  write_rule(starve_2, ++index);
  write_rule(starve_4, ++index);
  write_rule(starve_6, ++index);
  write_rule(starve_8, ++index);

  set_rules_active(index);

  write_type(0,1,1, 0xC);
  write_type(0,1,5, 0xC);
  write_type(0,5,1, 0xC);
  write_type(0,5,5, 0xC);

  // All non-feedbackcells have the same behavior
  for (int n = 1; n < 12; n++) {
    write_lut(LUT_ONE, n);
  }

  snn_t* network = create_network(info);
  for (int i = 0; i < info->ca_output_cell_count; i++) {
    network->layers[0].neurons[0].weights[i] = 1;
  }
  write_snn(network);
}

uint32_t colorfunction (uint32_t value) {
  if (value <= 0) {
    return 0xFFFFFF;
  }
  if (value <= 0xB) {
    return 0x588C7E;
  }
  if (value <= 0xC) {
    return 0xD96459;
  }
  if (value <= 0xD) {
    return 0xF2AE72;
  }
  if (value <= 0xE) {
    return 0xD46459;
  }
  return 0xFFFFFF;
}

uint32_t colorfunction2 (uint32_t value) {
  if (value == 0) {
    return 0xFFFFFF;
  }
  if (value == 1) {
    return 0x588C7E;
  }
  if (value == 2) {
    return 0xF2E394;
  }
  if (value == 3) {
    return 0xF2AE72;
  }
  if (value == 4) {
    return 0xD96459;
  }
  if (value == 5) {
    return 0xBCCAD6;
  }
  if (value == 6) {
    return 0x92A8D1;
  }
  if (value == 7) {
    return 0x034F84;
  }
  if (value == 8) {
    return 0xF7CAC9;
  }
  if (value == 9) {
    return 0xF7786B;
  }
  if (value == 0xA) {
    return 0xDEEAEE;
  }
  if (value == 0xB) {
    return 0xB1CBBB;
  }
  if (value == 0xC) {
    return 0xFFEF96;
  }
  if (value == 0xD) {
    return 0xB2B2B2;
  }
  if (value == 0xE) {
    return 0x36486B;
  }
  if (value == 0xF) {
    return 0xE3E0CC;
  }
  return 0xFFFFFF;
}

void demo() {
  printf("Demo: Feedback Regulated Replicator\n");
  printf("- Simple replicator regulated by readout feedback\n");

  init();

  for (int i = 0; i <= 20; i++) {
    read_types();

    char filename[20];
    sprintf(filename, "%02d.ps", i);

    matrix_t *type_matrix = get_types();
    print_matrix(type_matrix, info->type_bits);
    postscript_from_matrix_layer(type_matrix, 0, &colorfunction, filename);
    matrix_dispose(type_matrix);

    swap_cell_storage();
    config();
    step(2);
    readback();
    swap_cell_storage();
    read_states();
    print_matrix(get_states(), info->state_bits);

    develop();
    swap_cell_storage();
  }
}

int main() {
  info = carp_connect();
  carp_reset();
  demo();
  carp_disconnect();
  return 0;
}
