#include <stdlib.h>
#include "testframework.cinclude"

void test() {
  printf("Test: Readout\n");

  /*
   * 1. Set weight between next to last and the last layer to 2,
   *    all other weights 0, producing a clock pulse.
   * 2. Run 32 steps
   * 3. read_readout() -> get_readout()
   * 4. assert readout is clock pulse
   */

  snn_t* network = create_network(info);
  network->layers[2].neurons[0].weights[0] = 2;

  write_snn(network);

  step(32);
  read_readout();
  uint32_t* data = get_readout();
  // 0 0 0 1 0 1 0 1
  uint32_t prev = data[2];
  for (int i = 3; i < 32; i++) {
    assert_uint32((prev == 1) ? 0 : 1, data[i]);
    prev = data[i];
  }
}
