#include <stdlib.h>
#include "testframework.cinclude"

void test() {
  printf("Test: Readout->CA feedback\n");


  /* Matrix types:
   * 0 f 0
   * 0 | 0
   * 0 & 0
   * 0 0 0
   *
   * Matrix states before:
   * 0 0 0
   * 0 0 0
   * 1 0 1
   * 0 1 0
   *
   * Matrix states after 1:
   * 0 0 0
   * 0 0 0
   * 1 0 1
   * 0 1 0
   *
   * Matrix states after 2:
   * 0 1 0
   * 0 0 0
   * 1 0 1
   * 0 1 0
   *
   * Matrix states after 3:
   * 0 1 0
   * 0 1 0
   * 1 0 1
   * 0 1 0
   *
   * Matrix states after 4:
   * 0 1 0
   * 0 1 0
   * 1 1 1
   * 0 1 0
   */

  // Setup CA
  write_lut(LUT_SELF, 0);
  write_lut(LUT_AND4, 1);
  write_lut(LUT_OR,   2);

  write_type(0,1,1, 2);
  write_type(0,2,1, 1);

  write_state(0,2,0, 1);
  write_state(0,2,2, 1);
  write_state(0,3,1, 1);

  swap_cell_storage();
  config();

  step(1);
  readback();
  swap_cell_storage();
  read_state(0,0,1);
  assert_uint32(0, get_state());
  read_state(0,1,1);
  assert_uint32(0, get_state());
  read_state(0,2,1);
  assert_uint32(0, get_state());

  step(1);
  readback();
  swap_cell_storage();
  read_state(0,0,1);
  assert_uint32(1, get_state());
  read_state(0,1,1);
  assert_uint32(0, get_state());
  read_state(0,2,1);
  assert_uint32(0, get_state());

  step(1);
  readback();
  swap_cell_storage();
  read_state(0,0,1);
  assert_uint32(1, get_state());
  read_state(0,1,1);
  assert_uint32(1, get_state());
  read_state(0,2,1);
  assert_uint32(0, get_state());

  step(1);
  readback();
  swap_cell_storage();
  read_state(0,0,1);
  assert_uint32(1, get_state());
  read_state(0,1,1);
  assert_uint32(1, get_state());
  read_state(0,2,1);
  assert_uint32(1, get_state());
}
